---
title: MediaTrackSupportedConstraints.displaySurface
slug: Web/API/MediaTrackSupportedConstraints/displaySurface
tags:
  - API
  - Capture
  - Constraints
  - Media
  - Media Capture and Streams
  - Media Capture and Streams API
  - MediaTrackSupportedConstraints
  - Property
  - Reference
  - Screen Capture
  - Screen Capture API
  - Sharing
  - Video
  - display
  - displaySurface
  - screen
---
<p>{{APIRef("Media Capture and Streams")}}</p>

<p><span class="seoSummary">The {{domxref("MediaTrackSupportedConstraints")}} dictionary's <strong><code>displaySurface</code></strong> property indicates whether or not the {{domxref("MediaTrackConstraints.displaySurface", "displaySurface")}} constraint is supported by the user agent and the device on which the content is being used. </span></p>

<p>The supported constraints list is obtained by calling {{domxref("MediaDevices.getSupportedConstraints", "navigator.mediaDevices.getSupportedConstraints()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><em>isDisplaySurfaceSupported</em> = <em>supportedConstraints</em>.displaySurface;</pre>

<h3 id="Value">Value</h3>

<p>A Boolean value which is <code>true</code> if the {{domxref("MediaTrackConstraints.displaySurface", "displaySurface")}} constraint is supported by the device and user agent.</p>

<h2 id="Example">Example</h2>

<p>This method sets up the constraints object specifying the options for the call to {{domxref("MediaDevices.getDisplayMedia", "getDisplayMedia()")}}. It adds the <code>displaySurface</code> constraint (requesting that only full-screen sharing be allowed) only if it is known to be supported by the browser. Capturing is then started by calling <code>getDisplayMedia()</code> and attaching the returned stream to the video element referenced by the variable <code>videoElem</code>.</p>

<pre class="brush: js">async function capture() {
  let supportedConstraints = navigator.mediaDevices.getSupportedConstraints();
  let displayMediaOptions = {
    video: {
    },
    audio: false;
  };

  if (supportedConstraints.displaySurface) {
    displayMediaOptions.video.displaySurface = "monitor";
  }

  try {
    videoElem.srcObject = await navigator.mediaDevices.getDisplayMedia(displayMediaOptions);
  } catch(err) {
    /* handle the error */
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Screen Capture', '#dom-mediatracksupportedconstraints-displaysurface', 'MediaTrackSupportedConstraints.displaySurface')}}</td>
   <td>{{Spec2('Screen Capture')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.MediaTrackSupportedConstraints.displaySurface")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API">Screen Capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Screen_Capture_API/Using_Screen_Capture">Using the screen capture API</a></li>
 <li><a href="/en-US/docs/Web/API/Media_Streams_API/Constraints">Capabilities, constraints, and settings</a></li>
 <li>{{domxref("MediaDevices.getDisplayMedia()")}}</li>
 <li>{{domxref("MediaStreamTrack.getConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.applyConstraints()")}}</li>
 <li>{{domxref("MediaStreamTrack.getSettings()")}}</li>
</ul>
